// $Id: ListenPollReport.java,v 1.1 2007/12/12 21:22:03 osoysal Exp $

/** modified from original Listen app. 
This one is specific to pollcast
this is a try to use mig
*/
import java.io.*;
import java.util.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import net.tinyos.message.*;
/* magic string for messages
08 01 08 BD FF FF 7E 00 06 7D
06 should be the message type
*/

public class ListenPollReport
{
	public static void sendMessage(PacketSource source)
	{
		byte [] arr=new byte[PollCastControlMsg.DEFAULT_MESSAGE_SIZE+10];
		arr[0]=(byte)PollCastControlMsg.DEFAULT_MESSAGE_SIZE;
		arr[1]=(byte)0x01;
		arr[2]=(byte)PollCastControlMsg.DEFAULT_MESSAGE_SIZE;
		arr[3]=(byte)0xBD;
		arr[4]=(byte)0xFF;
		arr[5]=(byte)0xFF;
		arr[6]=(byte)0x7E;
		arr[7]=(byte)0x00;
		arr[8]=(byte)0x06;
		arr[9]=(byte)0x7D;
		PollCastControlMsg msg=new PollCastControlMsg(arr,10);
		msg.set_useCCA((short)1);
		msg.set_CCAInitDelay(0);
		msg.set_CCASampleDelay(0);
		msg.set_voteProb(1000);
		msg.set_voteRounds(1);
		System.out.println("Sending: ");
		Dump.printPacket(System.out, msg.dataGet());
		System.out.println();
		try
		{
			source.writePacket(arr);
		} catch (IOException e) {
		    System.err.println("Error on " + source.getName() + ": " + e);
		}
	}
    public static void main(String args[]) throws IOException 
	{
	
	PacketSource reader = BuildSource.makePacketSource();
	if (reader == null) {
	    System.err.println("Invalid packet source (check your MOTECOM environment variable)");
	    System.exit(2);
	}

	Vector<PollCastReportMsg> v=new Vector<PollCastReportMsg>();
	try {
	  reader.open(PrintStreamMessenger.err);
	  for (int j=0;;j++) {
	  
/*		sendMessage(reader);
		try {Thread.sleep(500);}
		catch(InterruptedException e){}
*/
	    byte[] packet = reader.readPacket();
		PollCastReportMsg rep=new PollCastReportMsg(packet,10);
		v.add(rep);
		Dump.printPacket(System.err,rep.dataGet());
		System.err.println();
	    Dump.printPacket(System.err, packet);
	    System.err.println();
		System.err.println(rep);
	    System.err.flush();
		int sumcrc=0;
		int sumcca=0;
		int sumrecv=0;
		int sumeither=0;
		int sumno=0;
		for (int i=0;i<v.size();i++)
		{
			PollCastReportMsg m=v.get(i);
			if (m.get_nCCAPositive()>1)
				sumcca++;
			if (m.get_nCRC()>0)
				sumcrc++;
			if (m.get_nReceived()>0)
				sumrecv++;
			if (m.get_nCCAPositive()>1 || m.get_nCRC()> 0 || m.get_nReceived()>0)
				sumeither++;
			else
				sumno++;
		}
		System.out.println("summary: "+(j+1)+"\t"+sumeither+"\t"+sumno+"\t"+sumrecv+"\t"+sumcrc+"\t"+sumcca+" ");
		System.out.flush();
	  }
	}
	catch (IOException e) {
	    System.err.println("Error on " + reader.getName() + ": " + e);
	}
    }
}

