#ifndef POLL_CAST_CONTROL_MSG_H
#define POLL_CAST_CONTROL_MSG_H
enum
{
	AM_POLLCASTCONTROLMSG = 6
};

typedef nx_struct PollCastControlMsg
{
	nx_uint8_t useCCA; // use CCA in this round
	nx_uint16_t CCAInitDelay; // initial CCA delay before starting CCA collection
	nx_uint16_t CCASampleDelay; // delay between successive CCA readings
	// the following two will be used later in Countcast
	nx_uint16_t voteProb; // voting probability (1000 means probability of 1, 0 means 0)
	nx_uint16_t voteRounds; // number of rounds of voting
} PollCastControlMsg;

#endif
